NetApp iSCSI driver can fail when extending vols > 8gb

Bug #1284182 reported by Andrew Kerr on 2014-02-24
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Cinder
Undecided
Andrew Kerr

Bug Description

In certain situations the NetApp iSCSI driver may fail when extending a volume. The volume's original size must be greater than 8 GB, and the new size must be larger than the max_resize allowed by the LUN's geometry. When this happens, the block count is larger than the 2^24 limit imposed by the create_clone zAPI. When this fails you will see the a message similar to this in c-vol logs:

2014-02-24 10:47:06.323 ERROR cinder.volume.manager [req-29171d1e-3712-4a48-9e39-093a4392c3aa fb3d9b18330442d2a0c3d6a617e1592b 602e9f3b7d8649fba03dbf42d5bf7db7] volume 33bb1da1-f0b9-4cfc-b04f-729b9d34471c: Error trying to extend volume
2014-02-24 10:47:06.323 TRACE cinder.volume.manager Traceback (most recent call last):
2014-02-24 10:47:06.323 TRACE cinder.volume.manager File "/opt/stack/cinder/cinder/volume/manager.py", line 1114, in extend_volume
2014-02-24 10:47:06.323 TRACE cinder.volume.manager self.driver.extend_volume(volume, new_size)
2014-02-24 10:47:06.323 TRACE cinder.volume.manager File "/opt/stack/cinder/cinder/volume/drivers/netapp/iscsi.py", line 598, in extend_volume
2014-02-24 10:47:06.323 TRACE cinder.volume.manager self._do_sub_clone_resize(path, new_size_bytes)
2014-02-24 10:47:06.323 TRACE cinder.volume.manager File "/opt/stack/cinder/cinder/volume/drivers/netapp/iscsi.py", line 702, in _do_sub_clone_resize
2014-02-24 10:47:06.323 TRACE cinder.volume.manager self._destroy_lun(new_path)
2014-02-24 10:47:06.323 TRACE cinder.volume.manager File "/opt/stack/cinder/cinder/openstack/common/excutils.py", line 68, in __exit__
2014-02-24 10:47:06.323 TRACE cinder.volume.manager six.reraise(self.type_, self.value, self.tb)
2014-02-24 10:47:06.323 TRACE cinder.volume.manager File "/opt/stack/cinder/cinder/volume/drivers/netapp/iscsi.py", line 697, in _do_sub_clone_resize
2014-02-24 10:47:06.323 TRACE cinder.volume.manager self._clone_lun(name, new_lun, block_count=block_count)
2014-02-24 10:47:06.323 TRACE cinder.volume.manager File "/opt/stack/cinder/cinder/volume/drivers/netapp/iscsi.py", line 988, in _clone_lun
2014-02-24 10:47:06.323 TRACE cinder.volume.manager self.client.invoke_successfully(clone_create, True)
2014-02-24 10:47:06.323 TRACE cinder.volume.manager File "/opt/stack/cinder/cinder/volume/drivers/netapp/api.py", line 220, in invoke_successfully
2014-02-24 10:47:06.323 TRACE cinder.volume.manager raise NaApiError(code, msg)
2014-02-24 10:47:06.323 TRACE cinder.volume.manager NaApiError: NetApp api failed. Reason - 13115:Integer value 41943040 out of range [1..2^24] for block-count
2014-02-24 10:47:06.323 TRACE cinder.volume.manager

Fix proposed to branch: master
Review: https://review.openstack.org/76008

Changed in cinder:
assignee: nobody → Andrew Kerr (andrew-kerr)
status: New → In Progress

Reviewed: https://review.openstack.org/76008
Committed: https://git.openstack.org/cgit/openstack/cinder/commit/?id=f0f52a0085a1f5bbd23e6cfa8f0ea935e8fd56c8
Submitter: Jenkins
Branch: master

commit f0f52a0085a1f5bbd23e6cfa8f0ea935e8fd56c8
Author: Andrew Kerr <email address hidden>
Date: Mon Feb 24 16:25:20 2014 -0500

    Segment LUN clones in NetApp iSCSI

    The NetApp ZAPI for clone_create and clone_start has a maximum size.
    This fix breaks the lun into consumable sizes for the ZAPI.

    Change-Id: Id4d0872c6099b7cfc73d806d772a3ae051a76b70
    Closes-Bug: 1284182

Changed in cinder:
status: In Progress → Fix Committed
Thierry Carrez (ttx) on 2014-03-05
Changed in cinder:
milestone: none → icehouse-3
status: Fix Committed → Fix Released
tags: added: havana-backport-potential
Thierry Carrez (ttx) on 2014-04-17
Changed in cinder:
milestone: icehouse-3 → 2014.1

Change abandoned by Alan Pevec (<email address hidden>) on branch: stable/havana
Review: https://review.openstack.org/78347
Reason: Final Havana release 2012.3.4 has been cut and stable/havana is going to be removed in a week.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers